var SS = {};  // Global object container

function init_images() {
    SS.img_off = "images/lb_off.png";

    SS.img_on = [ "images/lb_yellow.png",
                  "images/lb_blue.png",
                  "images/lb_green.png",
                  "images/lb_red.png",
                  "images/lb_purple.png"];

    SS.n = SS.img_on.length;

    SS.img_delay = 800;  
}

function init_sounds() {
    var snd_file = [ "sounds/f_sharp.wav",
                     "sounds/g_sharp.wav",
                     "sounds/a_sharp.wav",
                     "sounds/c_sharp.wav",
                     "sounds/d_sharp.wav"]
    var n = SS.n;  // dereference

    SS.lb_snd = new Array(n);
    for (var i = 0; i < n; i++ ) {
        SS.lb_snd[i] = new Audio( snd_file[i] );
    }

    SS.success_snd = new Audio("sounds/applause.wav");
    SS.failure_snd = new Audio("sounds/aww.wav");
}

function init_seq() {
    SS.max_notes = 4;

    SS.seq = new Array(SS.max_notes);
    for (var i = 0; i < SS.max_notes; i++) {
        SS.seq[i] = Math.floor(Math.random() * SS.n);
    }

    SS.seq_delay = SS.img_delay + 160;
    SS.interval_id = 0;
    SS.notes_played;
    SS.notes_clicked;
    SS.seq_length;
}

function init_binds(){
    document.addEventListener("click", onClick);
}

function turn_lb_on(i, image) {
    SS.lb_snd[i].load();
    SS.lb_snd[i].play();
    image.src = SS.img_on[i];
}

function turn_lb_off(image) {
    image.src = SS.img_off;
}

function lb_click(i) {
    var img_id = "lb_" + String(i);
    var image = document.getElementById(img_id);

    turn_lb_on(i, image);
    setTimeout( function(){turn_lb_off(image)}, SS.img_delay);
}

function play_one(){
    if (SS.notes_played < SS.seq_length) {
        lb_click( SS.seq[SS.notes_played] );
        SS.notes_played = SS.notes_played + 1;
    }
    else {
        clearInterval(SS.interval_id);
    }
}

function play_seq(){
    SS.notes_played = 0;
    SS.notes_clicked = 0;
    SS.interval_id = setInterval( function(){play_one()}, SS.seq_delay);
}

function game_over(player_won){
    document.removeEventListener('click', onClick);
    if (player_won) {
        SS.success_snd.play();
    }
    else {
        SS.failure_snd.play();
    }
}

function click_on_image(evt){
    var target_id;

    target_id = evt.target.id;
    if (null == target_id.match("lb_")) {
        return -1;
    }

    for (var i = 0; i < SS.n; i++) {
        lb_id = "lb_" + String(i);
        if (target_id == lb_id) {
            return i;
        }
    }
}

function check_seq_finished() {
    if (SS.notes_clicked != SS.seq_length) {
        return;
    }

    if (SS.notes_clicked < SS.max_notes) {
       SS.seq_length = SS.seq_length + 1;
       play_seq();
    }
    else {/* player won */
       game_over(true);
    }
}

//    if (SS.notes_played == SS.seq_length && SS.notes_played == SS.max_notes) {

function onClick(evt) {
    i = click_on_image(evt);
    if (i == -1) {
        return;
    }

    P("i = " + String(i));
    P("notes_clicked= " + String(SS.notes_clicked));
    lb_click(i);

    SS.notes_clicked = SS.notes_clicked + 1;
    if ( SS.seq[SS.notes_clicked - 1] == i) {
        check_seq_finished();
    } 
    else {     /* player clicked the wrong note */
        game_over(false);
    }
}

function play_game(i) {
    init_seq();
    init_binds();
    P(SS.seq);
    SS.seq_length = 1;
    play_seq();
}

window.onload = function() {
    init_images();
    init_sounds();
}

function P(i){
    console.log(i);
}